package filter;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;

import javax.microedition.io.Connector;
import javax.microedition.io.SocketConnection;

import main.Unit_J2ME;
import master.Master_J2ME;

import main.CMD_Enum;

public class QueryFilter_J2ME implements Unit_J2ME
{

	private static final String COMPOSER = " Composer: ";
	public static final String ALBUM_ARTIST = " AlbumArtist: ";
	public static final String GENRE = " Genre: ";
	public static final String DATE = " Date: ";
	public static final String TRACK = " Track: ";
	public static final int FILE_POSITION = 0;
	public static final int TIME_POSITION = 1;
	public static final int ARTIST_POSITION = 2;
	public static final int TITLE_POSITION = 3;
	public static final int ALBUM_POSITION = 4;
	public static final int YEAR_POSITION = 5;
	public static final int TAG_SIZE = 6;
	public boolean isReady = false;
	public static final String[] prefix = {
		Master_J2ME.FILE, Master_J2ME.TIME, Master_J2ME.ARTIST, Master_J2ME.TITLE, Master_J2ME.ALBUM, Master_J2ME.YEAR
	};
	private static final String ACK = "ACK";
	static final String OK = " OK";
	private InputStream is;
	private OutputStream os;
	public String[] urls = {"localhost:6600", "127.0.0.1:6600","","",""};
	public int cUrl = 0;
	private SocketConnection sc;
	private Master_J2ME master;

	public QueryFilter_J2ME(Master_J2ME master)
	{
		this.master = master;
	}

	public void die()
	{
		try {
			is.close();
			os.close();
			sc.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void init()
	{
		setConnection();
	}

	/**
	 * 
	 */
	public void setConnection() {
		System.out.print("Initialaising network...url is:"+urls[cUrl]+"......");
		// инициализация сокет-соединения
		try {
			sc = (SocketConnection) Connector.open("socket://"+urls[cUrl]);// открытие соединения
			System.out.print("connection opend...");
			sc.setSocketOption(SocketConnection.LINGER, 5);// таймаут

			is = sc.openInputStream();// открытие потока на вход
			os = sc.openOutputStream();// на выход
			readToOK();
			isReady = true;

		} catch (Exception e) {
			isReady = false;
			System.out.println("......faild");
			e.printStackTrace();
		}
		System.out.println("Query Filter Initiated");
	}

	private void readToOK()
	{
		System.out.println("g:rto");
		String s = "";
		while (!(s.startsWith(QueryFilter_J2ME.OK) || s.startsWith(ACK))) {
			s = getString();
		}
	}

	private String getString() 
	{
		System.out.print("r:");
		String s = " ";
		try { // ловим проблему с сетью
			while (!(s.charAt(s.length() - 1) == '\n')) {
				s += (char) is.read();
			}
		} catch (Exception e) {
			System.out.println("unable to get data from server!");
			e.printStackTrace();
		}
		if (s.startsWith(ACK)) {
			System.out.println("-------------------\nerror\n-------------------");
			s = OK+"\n";
		}
		System.out.print(s);
		return s.substring(0, s.length() - 1);
		
	}
	
	private void send(String cmd)
	{
		try {
			os.write((cmd + "\n").getBytes());
			System.out.println("s:" + cmd);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	public void initiateLoad()
	{

		String[] nurls = master.load("urls");
		if(nurls != null) 
			urls = nurls;
		cUrl = urls.length-1;	
	}

	public void initiateSave()
	{
		master.save("urls", urls);

	}

	public String[] request(String cmd, String key, String value, int cmdId) {
		System.out.println("Std command:" + cmd + "," + cmdId);
		if (cmdId == CMD_Enum.CMD_STATUS) {
			return getStatus(cmd, key);
		} else if (cmdId == CMD_Enum.CMD_PAUSE) {
			play_pause();
		} else if (cmdId < CMD_Enum.CMD_LIST) {
			return sendSimpleCommand(cmd, value);
		} else if (cmdId == CMD_Enum.CMD_LIST) {
			return getList(cmd, key, value);
		} else if (cmdId <= CMD_Enum.CMD_GET_PLAYLIST) {
			return getSongsInfo(cmd, value);
		}
		return null;
	}

	/**
	 * @param cmd
	 * @param key
	 * @return
	 */
	private String[] getStatus(String cmd, String key) {
		String s = "";
		System.out.println("status..." + "key is:" + key);
		send(cmd);
		while (!(s.startsWith(key) || s == " OK")) {
			s = getString();
		}
		s = s.substring(key.length());
		readToOK();// for status
		String[] out = new String[1];
		out[0] = s;
		return out;
	}

	/**
	 * 
	 */
	private void play_pause() {
		String s = "";
		System.out.println("pause...");
		send("status");
		while (!(s.startsWith(" state") || s == " OK")) {
			s = getString();
		}
		if (s.endsWith("play")) {
			send("pause 1");
		} else {
			send("pause 0");
		}
		readToOK();// for status
		readToOK();// for pause
	}

	/**
	 * @param cmd
	 * @param value
	 * @return
	 */
	private String[] sendSimpleCommand(String cmd, String value) {
		send(cmd + " " + value);
		readToOK();
		String[] out = {"OK"};
		return out;
	}

	/**
	 * @param cmd
	 * @param value
	 * @return
	 */
	private String[] getSongsInfo(String cmd, String value) {
		String s = "";
		int i = 0;
		Vector all = new Vector();
		send(cmd+" "+value);
		s = getString();
		for (i = 0; !((s.startsWith(OK)) && i % TAG_SIZE == 0); i++) {
			all.addElement(prefix[i % TAG_SIZE]);
			if (s.startsWith(Master_J2ME.POS) || s.startsWith(TRACK) || s.startsWith(GENRE) || s.startsWith(ALBUM_ARTIST) || s.startsWith(COMPOSER) || s.startsWith(Master_J2ME.ID)) {
				s = getString();
				i--;
			} else if (s.startsWith(prefix[i % TAG_SIZE])) {
				all.setElementAt(s, i);
				s = getString();
			} else if (s.startsWith(OK)) {
				continue;
			} else {
				s = getString();
				i--;
				System.out.println("uncnown tag. SKIPPED!");
			}
		}
		System.out.println("count:"+ i);
		String[] out = new String[i];
		for (int j = 0; j < i; j++) {
			out[j] = (String)all.elementAt(j);
			System.out.println("a:"+out[j]);
		}
		return out;
	}

	/**
	 * @param cmd
	 * @param key
	 * @param value
	 * @param s
	 * @return
	 */
	private String[] getList(String cmd, String key, String value) {
		String s = "";
		Vector all = new Vector();
		send(cmd + " " + value);
		int count = 0;
		for (int i = 0; !s.startsWith(OK); i++) {
			s = getString();
			if (key.compareTo("") == 0 || s.startsWith(key)) {
				count++;
				all.addElement(s);
			}
		}
		String[] out = new String[count];
		for (int j = 0; j < count; j++) {
			out[j] = ((String)all.elementAt(j)).substring(key.length());
		}
		return out;
	}
}
