/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import com.sun.lwuit.*;
import com.sun.lwuit.list.*;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;
import com.sun.lwuit.layouts.BorderLayout;
import java.util.Vector;
import main.Unit_J2ME;

/**
 *
 * @author odmin
 */
public class GUIArtists implements Unit_J2ME, ActionListener
{

	public static final int WM_CLOSE = 1;
	public static final int WM_SELECT = 2;
	private Form mForm;
	private static final Command mCloseCommand = new Command("Back", WM_CLOSE);
	private GUI_J2ME gui_ctl;
	private List mArtistList;
	private Vector list_content;
	private boolean ready;

	public GUIArtists(GUI_J2ME g_lnk)
	{
		gui_ctl = g_lnk;
		list_content = new Vector();
		ready = false;
		mForm = new Form("Artist selection");
	}

	public void init()
	{
		ready = true;
		mForm.removeAll();
		mForm.setCommandListener(this);
		mForm.setLayout(new BorderLayout());

		mArtistList = new List();
		//mArtistList.setHeight(-100);
		mArtistList.addActionListener(this);
		mForm.addComponent(BorderLayout.CENTER, mArtistList);

		mForm.addCommand(mCloseCommand);
		mForm.setBackCommand(mCloseCommand);
		mForm.show();
		updateArtistsList();
	}

	public void die()
	{
		mForm.setVisible(false);
		mForm.repaint();
		ready=false;
	}

	public void initiateLoad()
	{
	}

	public void initiateSave()
	{
	}

	public void actionPerformed(ActionEvent evt)
	{
		if (evt.getCommand() == mCloseCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_CLOSE);
		} else if (evt.getSource() == mArtistList) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_SELECT);
		}
	}

	public void setArtistsListContent(String[] cont)
	{
		list_content.removeAllElements();
		for (int i = 0; i < cont.length; i++) {
			list_content.addElement(cont[i]);
		}
	}

	public void updateArtistsList()
	{
		if (ready) {
			ListModel newMdl = new DefaultListModel(list_content);
			mArtistList.setModel(newMdl);
			mArtistList.repaint();
		}
	}

	public String getSelectedArtist()
	{
		return mArtistList.getSelectedItem().toString();
	}
}
