/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import main.*;
import com.sun.lwuit.*;
//import com.sun.lwuit.animations.CommonTransitions;
//import com.sun.lwuit.animations.Transition;
//import com.sun.lwuit.animations.Transition3D;
import com.sun.lwuit.events.*;
//import com.sun.lwuit.geom.Dimension;
import com.sun.lwuit.geom.Rectangle;
import com.sun.lwuit.impl.LWUITImplementation;
import com.sun.lwuit.layouts.*;
import com.sun.lwuit.list.*;
import com.sun.lwuit.plaf.*;
import com.sun.lwuit.util.*;
//import com.sun.lwuit.geom.Rectangle;
import java.io.*;
import java.util.Vector;

/**
 *
 * @author odmin
 */
public class GUIPlayScreen implements Unit_J2ME, ActionListener
{

	public static final int WM_CLOSE = 1;
	public static final int WM_PLAY = 2;
	public static final int WM_PAUSE_RESUME = 3;
	public static final int WM_STOP = 4;
	public static final int WM_NEXT = 5;
	public static final int WM_PREV = 6;
	public static final int WM_VOL_UP = 7;
	public static final int WM_VOL_DOWN = 8;
	public static final int WM_EDIT = 9;
	public static final int WM_DEL = 10;
	public static final int WM_URL = 11;
	public static final int WM_INFO = 12;
	private Form mForm;
	private Button mBt_prev;
	private Button mBt_play;
	private Button mBt_pause;
	private Button mBt_stop;
	private Button mBt_next;
	private Button mBt_vol_up;
	private Label volume;
	private Button mBt_vol_down;
	private static final Command mCloseCommand = new Command("Close", WM_CLOSE);
	private static final Command mEditCommand = new Command("Edit playlist", WM_EDIT);
	private static final Command mDelCommand = new Command("Del Song", WM_EDIT);
	private static final Command mUrlCommand = new Command("Connect", WM_URL);
	private static final Command mInfoCommand = new Command("Song Info", WM_INFO);
	private GUI_J2ME gui_ctl;
	private List mPlayList;
	private Vector list_content;
	private boolean ready;
	private String vol_text;

	public GUIPlayScreen(GUI_J2ME g)
	{
		gui_ctl = g;
		list_content = new Vector();
		ready = false;
		mForm = new Form("Mobile music player client");
	}

	public void init()
	{
		ready = true;
		mForm.removeAll();
		mForm.setCommandListener(this);
		mForm.setLayout(new BorderLayout());

		try {
			mBt_prev = loadImmageAndAppendItToAButton("/prev.png");
			mBt_play = loadImmageAndAppendItToAButton("/play.png");
			mBt_pause = loadImmageAndAppendItToAButton("/pause.png");
			mBt_stop = loadImmageAndAppendItToAButton("/stop.png");
			mBt_next = loadImmageAndAppendItToAButton("/next.png");
			mBt_vol_up = loadImmageAndAppendItToAButton("/vol_up.png");
			mBt_vol_down = loadImmageAndAppendItToAButton("/vol_down.png");
		} catch (IOException ioe) {
			System.out.println(ioe.getMessage());
		}
		volume = new Label();

		mPlayList = new List();
		mPlayList.setScrollAnimationSpeed(0);
		Rectangle rect = new Rectangle(0,0,mPlayList.getWidth(),mPlayList.getHeight());
		mPlayList.scrollRectToVisible(rect);
		mPlayList.addActionListener(this);
		mForm.addComponent(BorderLayout.CENTER, mPlayList);

		Container buttonBar = new Container(new BoxLayout(BoxLayout.Y_AXIS));
		buttonBar.addComponent(mBt_prev);
		buttonBar.addComponent(mBt_pause);
		buttonBar.addComponent(mBt_stop);
		buttonBar.addComponent(mBt_next);
		buttonBar.addComponent(mBt_vol_up);
		buttonBar.addComponent(volume);
		buttonBar.addComponent(mBt_vol_down);

		mForm.addComponent(BorderLayout.EAST, buttonBar);

		mForm.addCommand(mCloseCommand,0);
		mForm.addCommand(mDelCommand);
		mForm.addCommand(mEditCommand);
		mForm.addCommand(mUrlCommand);
		mForm.addCommand(mInfoCommand);
		mForm.setBackCommand(mCloseCommand);
		mForm.show();
		updatePlayList();
		updateVolumeLabel();
	}

	private Button loadImmageAndAppendItToAButton(String imgUrl) throws IOException
	{
		Image iprev = Image.createImage(imgUrl);
		Button trn = new Button(iprev);
		trn.addActionListener(this);
		return trn;
	}

	public void die()
	{
		mForm.setVisible(false);
		mForm.repaint();
		ready=false;
	}

	public void initiateSave()
	{
	}

	public void initiateLoad()
	{
	}

	public void actionPerformed(ActionEvent ae)
	{
		if (ae.getCommand() == mCloseCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_CLOSE);
		} else if (ae.getCommand() == mEditCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_EDIT);
		} else if (ae.getCommand() == mDelCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_DEL);
		} else if (ae.getCommand() == mUrlCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_URL);
		} else if (ae.getCommand() == mInfoCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_INFO);
		} else {
			if (ae.getSource() == mBt_prev) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_PREV);
			} else if (ae.getSource() == mBt_play) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_PLAY);
			} else if (ae.getSource() == mBt_pause) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_PAUSE_RESUME);
			} else if (ae.getSource() == mBt_stop) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_STOP);
			} else if (ae.getSource() == mBt_next) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_NEXT);
			} else if (ae.getSource() == mBt_vol_down) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_VOL_DOWN);
			} else if (ae.getSource() == mBt_vol_up) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_VOL_UP);
			} else if (ae.getSource() == mPlayList) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_PLAY);
			}
		}
	}

	public void setPlayListContent(String[] cont)
	{
		list_content.removeAllElements();
		for (int i = 0; i < cont.length; i++) {
			list_content.addElement(cont[i]);
		}
	}

	public void updatePlayList()
	{
		if (ready) {
			ListModel newMdl = new DefaultListModel(list_content);
			mPlayList.setModel(newMdl);
			mPlayList.repaint();
		}
	}

	public int getSelectedSongIndex()
	{
		if (ready) {
			return mPlayList.getSelectedIndex();
		} else {
			return -1;
		}
	}

	public void setVolumeLabelContent(String vol)
	{
		vol_text = vol;
	}

	public void updateVolumeLabel()
	{
		if (ready) {
			volume.setText(vol_text);
		}
	}
}
