/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import com.sun.lwuit.*;
import com.sun.lwuit.list.*;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;
import com.sun.lwuit.layouts.BorderLayout;
import java.util.Vector;
import main.Unit_J2ME;

/**
 *
 * @author odmin
 */
public class GUISongs implements Unit_J2ME, ActionListener
{

	public static final int WM_CLOSE = 1;
	public static final int WM_ADD = 2;
	private Form mForm;
	private static final Command mCloseCommand = new Command("Back", WM_CLOSE);
	private static final Command mAddCommand = new Command("Add", WM_ADD);
	private GUI_J2ME gui_ctl;
	private List mSongList;
	private Vector list_content;
	private boolean ready;

	public GUISongs(GUI_J2ME g_lnk)
	{
		gui_ctl = g_lnk;
		list_content = new Vector();
		ready = false;
		mForm = new Form("Song management");
	}

	public void init()
	{
		ready = true;
		mForm.removeAll();
		mForm.setCommandListener(this);
		mForm.setLayout(new BorderLayout());

		mSongList = new List();
		mSongList.addActionListener(this);
		mForm.addComponent(BorderLayout.CENTER, mSongList);

		mForm.addCommand(mCloseCommand);
		mForm.addCommand(mAddCommand);
		mForm.setBackCommand(mCloseCommand);
		mForm.show();
		updateSongsList();
	}

	public void die()
	{
		mForm.setVisible(false);
		mForm.repaint();
		ready=false;
	}

	public void initiateLoad()
	{
	}

	public void initiateSave()
	{
	}

	public void actionPerformed(ActionEvent evt)
	{
		if (evt.getCommand() == mCloseCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_CLOSE);
		} else if (evt.getCommand() == mAddCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_ADD);
		}
	}

	public void setSongsListContent(String[] cont)
	{
		list_content.removeAllElements();
		for (int i = 0; i < cont.length; i++) {
			list_content.addElement(cont[i]);
		}
	}

	public void updateSongsList()
	{
		if (ready) {
			ListModel newMdl = new DefaultListModel(list_content);
			mSongList.setModel(newMdl);
			mSongList.repaint();
		}
	}

	public int getSelectedSong()
	{
		return mSongList.getSelectedIndex();
	}
}