/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import main.*;
import com.sun.lwuit.*;
//import com.sun.lwuit.animations.CommonTransitions;
//import com.sun.lwuit.animations.Transition;
//import com.sun.lwuit.animations.Transition3D;
import com.sun.lwuit.events.*;
//import com.sun.lwuit.geom.Dimension;
import com.sun.lwuit.geom.Rectangle;
import com.sun.lwuit.impl.LWUITImplementation;
import com.sun.lwuit.layouts.*;
import com.sun.lwuit.list.*;
import com.sun.lwuit.plaf.*;
import com.sun.lwuit.util.*;
//import com.sun.lwuit.geom.Rectangle;
import java.io.*;
import java.util.Stack;
import java.util.Vector;

/**
 *
 * @author odmin
 */
public class GUIUrl implements Unit_J2ME, ActionListener
{

	public static final int WM_CLOSE = 1;
	public static final int WM_CONNECT = 2;
	public static final int WM_SELECT = 3;
	private Form mForm;
	private TextField mUrl;
	private ComboBox mUrls;
	private Button mBt_connect;
	private static final Command mCloseCommand = new Command("Close", WM_CLOSE);
	private GUI_J2ME gui_ctl;
	private boolean ready;
	private String cur_url;
	private Vector list_content;
	//private String url_text;

	public GUIUrl(GUI_J2ME g)
	{
		gui_ctl = g;
		ready = false;
		mForm = new Form("Connect to host");
		list_content = new Vector();
	}

	public void init()
	{
		ready = true;
		mForm.removeAll();
		mForm.setCommandListener(this);
		mForm.setLayout(new BorderLayout());

		mBt_connect = new Button("Connect");
		mBt_connect.addActionListener(this);
		mUrl = new TextField();
		mUrls = new ComboBox();
		mUrls.addActionListener(this);

		Container urlBar = new Container(new BoxLayout(BoxLayout.Y_AXIS));
		urlBar.addComponent(mUrl);
		urlBar.addComponent(mUrls);
		urlBar.addComponent(mBt_connect);

		mForm.addComponent(BorderLayout.CENTER, urlBar);

		mForm.addCommand(mCloseCommand);
		mForm.setBackCommand(mCloseCommand);
		mForm.show();
		updateUrlsList();
	}

	public void die()
	{
		mForm.setVisible(false);
		mForm.repaint();
		ready = false;
	}

	public void initiateSave()
	{
	}

	public void initiateLoad()
	{
	}

	public void actionPerformed(ActionEvent ae)
	{
		if (ae.getCommand() == mCloseCommand) {
			gui_ctl.ActionHandler(this.getClass().getName(), WM_CLOSE);
		} else {
			if (ae.getSource() == mBt_connect) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_CONNECT);
			} else if (ae.getSource() == mUrls) {
				gui_ctl.ActionHandler(this.getClass().getName(), WM_SELECT);
			}
		}
	}

	public void setUrlText(String text)
	{
		cur_url = text;
	}

	public String getUrlText()
	{
		if (ready) {
			return mUrl.getText();
		} else {
			return null;
		}
	}

	public void updateUrlText()
	{
		if (ready) {
			mUrl.setText(cur_url);
			mUrl.repaint();
		}
	}

	public void setUrls(String[] data)
	{
		list_content.removeAllElements();
		for (int i = 0; i < data.length; i++) {
			list_content.addElement(data[i]);
		}
	}

	public void updateUrlsList()
	{
		if (ready) {
			ListModel newMdl = new DefaultListModel(list_content);
			mUrls.setModel(newMdl);
			mUrls.repaint();
		}
	}

	public String getSelectedUrl()
	{
		return mUrls.getSelectedItem().toString();
	}
}
