/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import com.sun.lwuit.Dialog;
import main.*;
import master.Master_J2ME;
import com.sun.lwuit.Form;
import com.sun.lwuit.plaf.UIManager;
import com.sun.lwuit.util.Resources;
import java.io.IOException;
import main.Song_J2ME;

/**
 *
 * @author odmin
 */
public class GUI_J2ME implements Unit_J2ME
{

	Master_J2ME master_lnk;
	GUIPlayScreen play_scr;
	GUIArtists art_scr;
	GUIAlbums alb_scr;
	GUISongs song_scr;
	GUIUrl url_scr;
	Form whiteForm;
	int offset;
	int vol;
	Song_J2ME[] songs_from_db;
	String selected_artist;

	public GUI_J2ME(Master_J2ME m_lnk)
	{
		try {
			Resources r = Resources.open("/javaTheme.res");
			UIManager.getInstance().setThemeProps(r.getTheme("javaTheme"));
		} catch (IOException ioe) {
			System.out.println("Couldn't load theme.");
		}
		master_lnk = m_lnk;
		play_scr = new GUIPlayScreen(this);
		art_scr = new GUIArtists(this);
		alb_scr = new GUIAlbums(this);
		song_scr = new GUISongs(this);
		url_scr = new GUIUrl(this);
		offset = 0;
		vol = 0;
	}

	public void init()
	{
		whiteForm = new Form();
		whiteForm.show();
		updatePlayScreenContent();
		play_scr.init();
	}

	public void die()
	{
		play_scr.die();
	}

	public void initiateSave()
	{
	}

	public void initiateLoad()
	{
	}

	public void ActionHandler(String component, int action)
	{
		if (component.compareTo(GUIPlayScreen.class.getName()) == 0) {
			ActionHandler_GUIPlayScreen(action);
		} else if (component.compareTo(GUIArtists.class.getName()) == 0) {
			ActionHandler_GUIArtists(action);
		} else if (component.compareTo(GUIAlbums.class.getName()) == 0) {
			ActionHandler_GUIAlbums(action);
		} else if (component.compareTo(GUISongs.class.getName()) == 0) {
			ActionHandler_GUISongs(action);
		} else if (component.compareTo(GUIUrl.class.getName()) == 0) {
			ActionHandler_GUIUrl(action);
		}
	}

	public void ActionHandler_GUIPlayScreen(int action)
	{
		switch (action) {
			case GUIPlayScreen.WM_PLAY:
				int index = play_scr.getSelectedSongIndex();
				master_lnk.play(index);
				break;
			case GUIPlayScreen.WM_STOP:
				master_lnk.stop();
				break;
			case GUIPlayScreen.WM_PREV:
				master_lnk.prev();
				break;
			case GUIPlayScreen.WM_NEXT:
				master_lnk.next();
				break;
			case GUIPlayScreen.WM_PAUSE_RESUME:
				master_lnk.pause_resume();
				break;
			case GUIPlayScreen.WM_CLOSE:
				play_scr.die();
				System.gc();
				whiteForm.setVisible(true);
				whiteForm.repaint();
				master_lnk.initiateSave();
				master_lnk.die();
				break;
			case GUIPlayScreen.WM_VOL_DOWN:
				if (vol != 0) {
					vol--;
					master_lnk.setVolume(vol);
					vol = master_lnk.getVolume();
					play_scr.setVolumeLabelContent(Integer.toString(vol) + "%");
					play_scr.updateVolumeLabel();
				}
				break;
			case GUIPlayScreen.WM_VOL_UP:
				if (vol < 100) {
					vol++;
					master_lnk.setVolume(vol);
					vol = master_lnk.getVolume();
					play_scr.setVolumeLabelContent(Integer.toString(vol) + "%");
					play_scr.updateVolumeLabel();
				}
				break;
			case GUIPlayScreen.WM_EDIT:
				play_scr.die();
				System.gc();
				String[] artists = master_lnk.getArtists();
				String[] tmp = new String[artists.length + 1];
				for (int i = 0; i < artists.length; i++) {
					if (artists[i].compareTo(" ") == 0) {
						artists[i] = " << no artist >> ";
					}
					tmp[i] = artists[i];
				}
				tmp[artists.length] = "*";
				artists = tmp;
				art_scr.setArtistsListContent(artists);
				art_scr.init();
				break;
			case GUIPlayScreen.WM_DEL:
				master_lnk.delete(play_scr.getSelectedSongIndex());
				master_lnk.updateDb();
				updatePlayScreenContent();
				play_scr.updatePlayList();
				break;
			case GUIPlayScreen.WM_URL:
				play_scr.die();
				System.gc();
				url_scr.setUrls(master_lnk.getUrls());
				url_scr.init();
				break;
			case GUIPlayScreen.WM_INFO:
				int sel = play_scr.getSelectedSongIndex();
				Song_J2ME song = master_lnk.getSong(sel);
				String info = "Title: " + song.title + "\nArtist: " +
						song.artist + "\nAlbum: " + song.album + "\nDate: " +
						song.date + "\nDuration: " +
						Integer.toString(song.duration / 60) + ":" +
						Integer.toString(song.duration % 60) + "\nFile: " +
						song.file;
				Dialog.show("song info", info, "OK", "OK");
				break;
			default:
		}
	}

	private void ActionHandler_GUIArtists(int action)
	{
		switch (action) {
			case GUIArtists.WM_CLOSE:
				art_scr.die();
				System.gc();
				master_lnk.updateDb();
				updatePlayScreenContent();
				play_scr.init();
				break;
			case GUIArtists.WM_SELECT:
				selected_artist = art_scr.getSelectedArtist();
				if (selected_artist.compareTo(" << no artist >> ") == 0) {
					selected_artist = " ";
				}
				art_scr.die();
				System.gc();
				updateArtistsContent();
				alb_scr.init();
				break;
			default:
		}
	}

	private void ActionHandler_GUIAlbums(int action)
	{
		switch (action) {
			case GUIAlbums.WM_CLOSE:
				alb_scr.die();
				System.gc();
				art_scr.init();
				break;
			case GUIAlbums.WM_SELECT:
				String sel = alb_scr.getSelectedAlbum();
				if (sel.compareTo(" << no artist >> ") == 0) {
					sel = " ";
				}
				alb_scr.die();
				System.gc();
				if (sel.compareTo("*") == 0) {
					if (selected_artist.compareTo("*") == 0) {
						songs_from_db = master_lnk.getSong("", "");
					} else {
						songs_from_db = master_lnk.getSong("artist", selected_artist);
					}
				} else {
					songs_from_db = master_lnk.getSong("album", sel);
				}
				String[] to_list = new String[songs_from_db.length];
				for (int i = 0; i < songs_from_db.length; i++) {
					to_list[i] = songs_from_db[i].title;
				}
				song_scr.setSongsListContent(to_list);
				song_scr.init();
				break;
			default:
		}
	}

	private void ActionHandler_GUISongs(int action)
	{
		switch (action) {
			case GUISongs.WM_CLOSE:
				song_scr.die();
				System.gc();
				alb_scr.init();
				break;
			case GUISongs.WM_ADD:
				int sel = song_scr.getSelectedSong();
				if (sel == -1) {
					return;
				}
				master_lnk.addByUrl(songs_from_db[sel].file);
				System.out.println(songs_from_db[sel].file);
				break;
			default:
		}
	}

	private void ActionHandler_GUIUrl(int action)
	{
		switch (action) {
			case GUIUrl.WM_CONNECT:
				String url = url_scr.getUrlText();
				master_lnk.setUrl(url);
			//break; //ЫТЬ! - no breaks
			case GUIUrl.WM_CLOSE:
				url_scr.die();
				System.gc();
				updatePlayScreenContent();
				play_scr.init();
				break;
			case GUIUrl.WM_SELECT:
				url_scr.setUrlText(url_scr.getSelectedUrl());
				url_scr.updateUrlText();
				break;
			default:
		}
	}

	private void updateArtistsContent()
	{
		String[] albums = master_lnk.getAlbums(selected_artist);
		String[] tmp = new String[albums.length + 1];
		for (int i = 0; i < albums.length; i++) {
			if (albums[i].compareTo(" ") == 0) {
				albums[i] = " << no albums >> ";
			}
			tmp[i] = albums[i];
		}
		tmp[albums.length] = "*";
		albums = tmp;
		alb_scr.setAlbumsListContent(albums);
	}

	private void updatePlayScreenContent()
	{
		Song_J2ME[] pl = master_lnk.getPlaylist(0, -1);
		System.out.println("pl:" + pl.length);
		if (pl != null) {
			String[] playlist = new String[pl.length];
			for (int i = 0; i < pl.length; i++) {
				playlist[i] = pl[i].title + " <> " + pl[i].artist +
						" ........  " + pl[i].duration / 60 + ":" +
						pl[i].duration % 60;
				System.out.println(playlist[i]);
			}
			play_scr.setPlayListContent(playlist);
			vol = master_lnk.getVolume();
			play_scr.setVolumeLabelContent(Integer.toString(vol) + "%");
		}
	}
}
