package storage;

import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;
import main.Unit_J2ME;
import master.Master_J2ME;

public class Storage_J2ME implements Unit_J2ME
{

	public Storage_J2ME(Master_J2ME m_lnk)
	{
	}

	private void printError(String error)
	{
		System.out.println("Exception: " + error);
	}

	private RecordStore open(String label)
	{
		RecordStore ret = null;
		try {			                                          //открываем по указанному лэйблу
			ret = RecordStore.openRecordStore(label, true);
		} catch (Exception exc) {
			printError(exc.toString());
		}
		return ret;
	}

	private void delete(String label)
	{
		if (RecordStore.listRecordStores() != null) {
			try {
				RecordStore.deleteRecordStore(label);
			} catch (Exception exc) {
				printError(exc.toString());
			}
		}
	}

	private void close(RecordStore rs)
	{
		try {                                                     //закрываем
			rs.closeRecordStore();
		} catch (Exception exc) {
			printError(exc.toString());
		}
	}

	public void save(String label, byte[] data)
	{
		RecordStore record = open(label);
		delete(label);

		try {                                                    //записываем по лэйблу
			record.addRecord(data, 0, data.length);
		} catch (Exception exc) {
			printError(exc.toString());
		}

		close(record);
	}

	public byte[] load(String label)
	{
		RecordStore record = open(label);
		byte[] tmp = new byte[0];
		try {
			if (record.getNumRecords() > 0) {
				RecordEnumeration re;
				re = record.enumerateRecords(null, null, false);
				while (re.hasNextElement()) {
					tmp = re.nextRecord();
				}
			}
		} catch (Exception exc) {
			printError(exc.toString());
		}
		close(record);
		return tmp;
	}

	public void init()
	{
	}

	public void die()
	{
	}

	public void initiateLoad()
	{
	}

	public void initiateSave()
	{
	}
}
